@echo off

setlocal EnableDelayedExpansion

set vialver=0p4p1
set nathanaver=r5

set bootids[0]=2341:0037
set bootids[1]=1B4F:9205
set bootid=0
set bootidlen=0
:lencount 
if defined bootids[%bootidlen%] ( 
	set /a bootidlen+=1
	goto :lencount 
)
set /a bootidlen=%bootidlen%-1

for /f "tokens=2,3 delims=-" %%a in ("%~n0") do (
	set model=%%a
	set keymap=%%b
)

if "%model%" == "" exit /b 1
if "%keymap%" == "" exit /b 1

echo Preparing to flash firmware for "%model%" with keymap "%keymap%"...
for /l %%i in (0,1,%bootidlen%) do (
	set bootid=%%i
	"%~dp0\..\..\flash-util\avrdude.exe" -p atmega32u4 -c avr109 -P usb:!bootids[%%i]! -e > NUL 2>&1
	if not errorlevel 1 goto flash
)
echo.
echo Please plug in keyboard to be flashed, and put into bootloader/flash mode.
echo Waiting for keyboard...
:waitforusb1
set bootid=0
for /l %%i in (0,1,%bootidlen%) do (
	set bootid=%%i
	"%~dp0\..\..\flash-util\avrdude.exe" -p atmega32u4 -c avr109 -P usb:!bootids[%%i]! -e > NUL 2>&1
	if not errorlevel 1 goto flash
)
goto waitforusb1
:flash
echo.
echo * ...existing flash memory wiped.
echo * Wiping existing EEPROM...
"%~dp0\..\..\flash-util\avrdude.exe" -p atmega32u4 -c avr109 -P usb:!bootids[%bootid%]! -U eeprom:w:"%~dp0\..\..\flash-util\reset.eep":i > NUL 2>&1
echo * Flashing "%keymap%" keymap...
"%~dp0\..\..\flash-util\avrdude.exe" -p atmega32u4 -c avr109 -P usb:!bootids[%bootid%]! -U eeprom:w:"%~dp0\..\..\keymaps\%model%\%model%-%keymap%.hex":i > NUL 2>&1
echo * Flashing "%model%" firmware...
"%~dp0\..\..\flash-util\avrdude.exe" -p atmega32u4 -c avr109 -P usb:!bootids[%bootid%]! -U flash:w:"%~dp0\..\..\firmwares\%model%-vial-%vialver%_%nathanaver%.hex":i > NUL 2>&1
echo.
echo ...done!
echo.
pause
endlocal
